unit uTEST;

// Binuar 1.1
// Big number arithmetic
// ---
// Copyright  2000-3000, Andrey A. Meshkov (AL-CHEMIST)
// All rights reserved
//
// http://maalchemist.ru
// maa@maalchemist.ru
// maalchemist@yandex.ru
// maalchemist@gmail.com
//
// Free for any use.
// No warranty of any kind.
// ---

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls;

type
  TmForm = class(TForm)
    StatusBar: TStatusBar;
    P_Buttons: TPanel;
    P_LOG: TPanel;
    ED_LOG: TMemo;
    BT_TEST: TButton;
    BT_Clear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BT_ClearClick(Sender: TObject);
    procedure BT_TESTClick(Sender: TObject);
  end;

var
  mForm: TmForm;

implementation

{$R *.DFM}

uses
  mxBNMath, mxBNMathUtils, mxBNMathProcs, mxBNMathConv;

{
}
procedure Refresh_(var T: DWORD; AForce: Boolean = false);
begin
  if AForce then begin
    Application.ProcessMessages;
    T := GetTickCount;
    Exit;
  end;

  if GetTickCount - T > 400 then begin
    Application.ProcessMessages;
    T := GetTickCount;
  end;
end;

{
}
procedure TmForm.FormCreate(Sender: TObject);
begin
//
end;

{
}
procedure TmForm.BT_ClearClick(Sender: TObject);
begin
  ED_LOG.Lines.Clear;
end;

{
}
procedure TmForm.BT_TESTClick(Sender: TObject);
var
  T       : DWORD;

  bnx_0   : T_BNX;
  bnx_1   : T_BNX;
  bnx_2   : T_BNX;
  bnx_100 : T_BNX;
  bnx_R   : T_BNX;

  R       : Integer;
  S_1     : string;
  S_2     : string;
  S_R     : string;

  VCursor : TCursor;
begin
  T := GetTickCount;

  VCursor := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_add TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_add (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('+');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_sub TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_sub (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('-');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_sub TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_sub (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('-');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mul TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_mul (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('*');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_div TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    R := BN_div (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('/');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('R = ' + IntToStr (R));
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_div TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    R := BN_div (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('/');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('R = ' + IntToStr (R));
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mod TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    R := BN_mod (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('%');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('R = ' + IntToStr (R));
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mod TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    R := BN_mod (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('%');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('R = ' + IntToStr (R));
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('####################');
    ED_LOG.Lines.ADD ('##  BN_sqrt TEST  ##');
    ED_LOG.Lines.ADD ('####################');
    // ----
    BN_exp_int (bnx_100, 1, 100, 1111); // bnx_100 = (100^1111)
    BN_mul_int (bnx_0, bnx_100, 1, 2);  // bnx_0   = (100^1111)*2
    R := BN_sqrt (bnx_2, bnx_0);        // bnx_2   = sqrt((100^1111)*2)
    // ----
    S_R := BN_Base10 (bnx_2);
    ED_LOG.Lines.ADD ('sqrt(2*(100^1111)) = sqrt(2)*(10^1111) = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('R = ' + IntToStr (R));
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('########################');
    ED_LOG.Lines.ADD ('##  BN_fact_int TEST  ##');
    ED_LOG.Lines.ADD ('########################');
    // ----
    BN_fact_int (bnx_0, 1111); // bnx_0 = 1111!
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('1111! = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);
  finally
    Screen.Cursor := VCursor;
  end;

  Refresh_(T, true);
end;

end.

